1. Prep git repo: `git init`
1. `echo 18 > .nvmrc && nvm use`
1. Setup `package.json`: `npm init -y`
1. Update `package.json` via `jsii-config`: `npx jsii-config`
1. Populate [required metadata](https://aws.github.io/jsii/user-guides/lib-author/quick-start/set-up/#adding-mandatory-metadata):
   > Then, add the mandatory information to the new `package.json` file that was created. Specifically, _jsii modules_ must
   > have an `author` and `repository` setting (those are necessary to generate _valid_ libraries for certain distribution
   > points, such as _Maven Central_):
   >
   > ```json hl_lines="4 10-13 14-16"
   > {
   >   "name": "project-name",
   >   "version": "1.0.0",
   >   "description": "A demonstration jsii library",
   >   "main": "index.js",
   >   "scripts": {
   >     "test": "echo \"Error: no test specified\" && exit 1"
   >   },
   >   "keywords": [],
   >   "author": {
   >     "name": "John Doe",
   >     "email": "john.doe@acme.com"
   >   },
   >   "repository": {
   >     "url": "https://github.com/acme/project-name.git"
   >   },
   >   "license": "ISC"
   > }
   > ```
1. Install dependencies: `yarn add -D jsii jsii-pacmak`
1. Create README: `touch README.md`
